<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>GStreamer Good Plugins 1.0 Plugins Reference Manual: equalizer-nbands</title>
<meta name="generator" content="DocBook XSL Stylesheets V1.78.1">
<link rel="home" href="index.html" title="GStreamer Good Plugins 1.0 Plugins Reference Manual">
<link rel="up" href="ch01.html" title="gst-plugins-good Elements">
<link rel="prev" href="gst-plugins-good-plugins-equalizer-3bands.html" title="equalizer-3bands">
<link rel="next" href="gst-plugins-good-plugins-flacdec.html" title="flacdec">
<meta name="generator" content="GTK-Doc V1.20 (XML mode)">
<link rel="stylesheet" href="style.css" type="text/css">
</head>
<body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF">
<table class="navigation" id="top" width="100%" summary="Navigation header" cellpadding="2" cellspacing="10"><tr valign="middle">
<td width="100%" align="left" class="shortcuts">
<a href="#" class="shortcut">Top</a><span id="nav_description"> <span class="dim">|</span> 
                  <a href="#gst-plugins-good-plugins-equalizer-nbands.description" class="shortcut">Description</a></span><span id="nav_hierarchy"> <span class="dim">|</span> 
                  <a href="#gst-plugins-good-plugins-equalizer-nbands.object-hierarchy" class="shortcut">Object Hierarchy</a></span><span id="nav_interfaces"> <span class="dim">|</span> 
                  <a href="#gst-plugins-good-plugins-equalizer-nbands.implemented-interfaces" class="shortcut">Implemented Interfaces</a></span><span id="nav_properties"> <span class="dim">|</span> 
                  <a href="#gst-plugins-good-plugins-equalizer-nbands.properties" class="shortcut">Properties</a></span>
</td>
<td><a accesskey="h" href="index.html"><img src="home.png" width="16" height="16" border="0" alt="Home"></a></td>
<td><a accesskey="u" href="ch01.html"><img src="up.png" width="16" height="16" border="0" alt="Up"></a></td>
<td><a accesskey="p" href="gst-plugins-good-plugins-equalizer-3bands.html"><img src="left.png" width="16" height="16" border="0" alt="Prev"></a></td>
<td><a accesskey="n" href="gst-plugins-good-plugins-flacdec.html"><img src="right.png" width="16" height="16" border="0" alt="Next"></a></td>
</tr></table>
<div class="refentry">
<a name="gst-plugins-good-plugins-equalizer-nbands"></a><div class="titlepage"></div>
<div class="refnamediv"><table width="100%"><tr>
<td valign="top">
<h2><span class="refentrytitle"><a name="gst-plugins-good-plugins-equalizer-nbands.top_of_page"></a>equalizer-nbands</span></h2>
<p>equalizer-nbands — Direct Form IIR equalizer</p>
</td>
<td class="gallery_image" valign="top" align="right"></td>
</tr></table></div>
<div class="refsect1">
<a name="gst-plugins-good-plugins-equalizer-nbands.properties"></a><h2>Properties</h2>
<div class="informaltable"><table border="0">
<colgroup>
<col width="150px" class="properties_type">
<col width="300px" class="properties_name">
<col width="200px" class="properties_flags">
</colgroup>
<tbody><tr>
<td class="property_type"><a href="http://library.gnome.org/devel/glib/unstable/glib-Basic-Types.html#guint"><span class="type">guint</span></a></td>
<td class="property_name"><a class="link" href="gst-plugins-good-plugins-equalizer-nbands.html#GstIirEqualizerNBands--num-bands" title="The “num-bands” property">num-bands</a></td>
<td class="property_flags">Read / Write / Construct</td>
</tr></tbody>
</table></div>
</div>
<a name="GstIirEqualizerNBands"></a><div class="refsect1">
<a name="gst-plugins-good-plugins-equalizer-nbands.other"></a><h2>Types and Values</h2>
<div class="informaltable"><table width="100%" border="0">
<colgroup>
<col width="150px" class="name">
<col class="description">
</colgroup>
<tbody><tr>
<td class="datatype_keyword">struct</td>
<td class="function_name"><a class="link" href="gst-plugins-good-plugins-equalizer-nbands.html#GstIirEqualizerNBands-struct" title="struct GstIirEqualizerNBands">GstIirEqualizerNBands</a></td>
</tr></tbody>
</table></div>
</div>
<div class="refsect1">
<a name="gst-plugins-good-plugins-equalizer-nbands.object-hierarchy"></a><h2>Object Hierarchy</h2>
<pre class="screen">    <a href="http://library.gnome.org/devel/gobject/unstable/gobject-The-Base-Object-Type.html#GObject">GObject</a>
    <span class="lineart">╰──</span> <a href="http://library.gnome.org/devel/gobject/unstable/gobject-The-Base-Object-Type.html#GInitiallyUnowned">GInitiallyUnowned</a>
        <span class="lineart">╰──</span> <a href="http://gstreamer.freedesktop.org/data/doc/gstreamer/head/gstreamer/html/GstObject.html">GstObject</a>
            <span class="lineart">╰──</span> <a href="http://gstreamer.freedesktop.org/data/doc/gstreamer/head/gstreamer/html/GstElement.html">GstElement</a>
                <span class="lineart">╰──</span> <a href="http://gstreamer.freedesktop.org/data/doc/gstreamer/head/gstreamer-libs/html/GstBaseTransform.html">GstBaseTransform</a>
                    <span class="lineart">╰──</span> <a href="http://gstreamer.freedesktop.org/data/doc/gstreamer/head/gst-plugins-base-libs/html/gst-plugins-base-libs-gstaudiofilter.html#GstAudioFilter">GstAudioFilter</a>
                        <span class="lineart">╰──</span> <a class="link" href="GstIirEqualizer.html" title="GstIirEqualizer">GstIirEqualizer</a>
                            <span class="lineart">╰──</span> GstIirEqualizerNBands
</pre>
</div>
<div class="refsect1">
<a name="gst-plugins-good-plugins-equalizer-nbands.implemented-interfaces"></a><h2>Implemented Interfaces</h2>
<p>
GstIirEqualizerNBands implements
 <a href="http://gstreamer.freedesktop.org/data/doc/gstreamer/head/gstreamer/html/GstChildProxy.html">GstChildProxy</a> and  <a href="http://gstreamer.freedesktop.org/data/doc/gstreamer/head/gstreamer/html/GstPreset.html">GstPreset</a>.</p>
</div>
<div class="refsect1">
<a name="gst-plugins-good-plugins-equalizer-nbands.description"></a><h2>Description</h2>
<p>The n-band equalizer element is a fully parametric equalizer. It allows to
select between 1 and 64 bands and has properties on each band to change
the center frequency, band width and gain.</p>
<div class="refsect2">
<a name="id-1.2.51.8.3"></a><h3>Example launch line</h3>
<div class="informalexample">
  <table class="listing_frame" border="0" cellpadding="0" cellspacing="0">
    <tbody>
      <tr>
        <td class="listing_lines" align="right"><pre>1</pre></td>
        <td class="listing_code"><pre class="programlisting">gst<span class="gtkdoc opt">-</span>launch<span class="gtkdoc opt">-</span><span class="number">1.0</span> filesrc location<span class="gtkdoc opt">=</span>song<span class="gtkdoc opt">.</span>ogg <span class="gtkdoc opt">!</span> oggdemux <span class="gtkdoc opt">!</span> vorbisdec <span class="gtkdoc opt">!</span> audioconvert <span class="gtkdoc opt">!</span> equalizer<span class="gtkdoc opt">-</span>nbands num<span class="gtkdoc opt">-</span>bands<span class="gtkdoc opt">=</span><span class="number">15</span> band5<span class="gtkdoc opt">::</span>gain<span class="gtkdoc opt">=</span><span class="number">6.0</span> <span class="gtkdoc opt">!</span> alsasink</pre></td>
      </tr>
    </tbody>
  </table>
</div>
 This make the equalizer use 15 bands and raises the volume of the 5th band by 6 db.
</div>
<hr>
<div class="refsect2">
<a name="id-1.2.51.8.4"></a><h3>Example code</h3>
<div class="informalexample">
  <table class="listing_frame" border="0" cellpadding="0" cellspacing="0">
    <tbody>
      <tr>
        <td class="listing_lines" align="right"><pre>1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38</pre></td>
        <td class="listing_code"><pre class="programlisting"><span class="gtkdoc ppc">#include &lt;gst/gst.h&gt;</span>

<span class="gtkdoc opt">...</span>
<span class="gtkdoc kwc">typedef</span> <span class="gtkdoc kwb">struct</span> <span class="gtkdoc opt">{</span>
  gfloat freq<span class="gtkdoc opt">;</span>
  gfloat width<span class="gtkdoc opt">;</span>
  gfloat gain<span class="gtkdoc opt">;</span>
<span class="gtkdoc opt">}</span> GstEqualizerBandState<span class="gtkdoc opt">;</span>

<span class="gtkdoc opt">...</span>

  GstElement <span class="gtkdoc opt">*</span>equalizer<span class="gtkdoc opt">;</span>
  GstObject <span class="gtkdoc opt">*</span>band<span class="gtkdoc opt">;</span>
  gint i<span class="gtkdoc opt">;</span>
  GstEqualizerBandState state<span class="gtkdoc opt">[] = {</span>
    <span class="gtkdoc opt">{</span> <span class="number">120.0</span><span class="gtkdoc opt">,</span>   <span class="number">50.0</span><span class="gtkdoc opt">, -</span> <span class="number">3.0</span><span class="gtkdoc opt">},</span>
    <span class="gtkdoc opt">{</span> <span class="number">500.0</span><span class="gtkdoc opt">,</span>   <span class="number">20.0</span><span class="gtkdoc opt">,</span>  <span class="number">12.0</span><span class="gtkdoc opt">},</span>
    <span class="gtkdoc opt">{</span><span class="number">1503.0</span><span class="gtkdoc opt">,</span>    <span class="number">2.0</span><span class="gtkdoc opt">, -</span><span class="number">20.0</span><span class="gtkdoc opt">},</span>
    <span class="gtkdoc opt">{</span><span class="number">6000.0</span><span class="gtkdoc opt">,</span> <span class="number">1000.0</span><span class="gtkdoc opt">,</span>   <span class="number">6.0</span><span class="gtkdoc opt">},</span>
    <span class="gtkdoc opt">{</span><span class="number">3000.0</span><span class="gtkdoc opt">,</span>  <span class="number">120.0</span><span class="gtkdoc opt">,</span>   <span class="number">2.0</span><span class="gtkdoc opt">}</span>
  <span class="gtkdoc opt">};</span>

<span class="gtkdoc opt">...</span>

  equalizer <span class="gtkdoc opt">=</span> <span class="function"><a href="http://gstreamer.freedesktop.org/data/doc/gstreamer/head/gstreamer/html/GstElementFactory.html#gst-element-factory-make">gst_element_factory_make</a></span> <span class="gtkdoc opt">(</span><span class="string">&quot;equalizer-nbands&quot;</span><span class="gtkdoc opt">,</span> <span class="string">&quot;equalizer&quot;</span><span class="gtkdoc opt">);</span>
  <span class="function"><a href="http://library.gnome.org/devel/gobject/unstable/gobject-The-Base-Object-Type.html#g-object-set">g_object_set</a></span> <span class="gtkdoc opt">(</span><span class="function"><a href="http://library.gnome.org/devel/gobject/unstable/gobject-The-Base-Object-Type.html#G-OBJECT:CAPS">G_OBJECT</a></span> <span class="gtkdoc opt">(</span>equalizer<span class="gtkdoc opt">),</span> <span class="string">&quot;num-bands&quot;</span><span class="gtkdoc opt">,</span> <span class="number">5</span><span class="gtkdoc opt">,</span> NULL<span class="gtkdoc opt">);</span>

<span class="gtkdoc opt">...</span>

  <span class="keyword">for</span> <span class="gtkdoc opt">(</span>i <span class="gtkdoc opt">=</span> <span class="number">0</span><span class="gtkdoc opt">;</span> i <span class="gtkdoc opt">&lt;</span> <span class="number">5</span><span class="gtkdoc opt">;</span> i<span class="gtkdoc opt">++) {</span>
    band <span class="gtkdoc opt">=</span> <span class="function"><a href="http://gstreamer.freedesktop.org/data/doc/gstreamer/head/gstreamer/html/GstChildProxy.html#gst-child-proxy-get-child-by-index">gst_child_proxy_get_child_by_index</a></span> <span class="gtkdoc opt">(</span><span class="function">GST_CHILD_PROXY</span> <span class="gtkdoc opt">(</span>equalizer<span class="gtkdoc opt">),</span> i<span class="gtkdoc opt">);</span>
    <span class="function"><a href="http://library.gnome.org/devel/gobject/unstable/gobject-The-Base-Object-Type.html#g-object-set">g_object_set</a></span> <span class="gtkdoc opt">(</span><span class="function"><a href="http://library.gnome.org/devel/gobject/unstable/gobject-The-Base-Object-Type.html#G-OBJECT:CAPS">G_OBJECT</a></span> <span class="gtkdoc opt">(</span>band<span class="gtkdoc opt">),</span> <span class="string">&quot;freq&quot;</span><span class="gtkdoc opt">,</span> state<span class="gtkdoc opt">[</span>i<span class="gtkdoc opt">].</span>freq<span class="gtkdoc opt">,</span>
        <span class="string">&quot;bandwidth&quot;</span><span class="gtkdoc opt">,</span> state<span class="gtkdoc opt">[</span>i<span class="gtkdoc opt">].</span>width<span class="gtkdoc opt">,</span>
	<span class="string">&quot;gain&quot;</span><span class="gtkdoc opt">,</span> state<span class="gtkdoc opt">[</span>i<span class="gtkdoc opt">].</span>gain<span class="gtkdoc opt">);</span>
    <span class="function"><a href="http://library.gnome.org/devel/gobject/unstable/gobject-The-Base-Object-Type.html#g-object-unref">g_object_unref</a></span> <span class="gtkdoc opt">(</span><span class="function"><a href="http://library.gnome.org/devel/gobject/unstable/gobject-The-Base-Object-Type.html#G-OBJECT:CAPS">G_OBJECT</a></span> <span class="gtkdoc opt">(</span>band<span class="gtkdoc opt">));</span>
  <span class="gtkdoc opt">}</span>

<span class="gtkdoc opt">...</span></pre></td>
      </tr>
    </tbody>
  </table>
</div>

</div>
<div class="refsynopsisdiv">
<h2>Synopsis</h2>
<div class="refsect2">
<a name="id-1.2.51.8.5.1"></a><h3>Element Information</h3>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term">plugin</span></p></td>
<td>
            <a class="link" href="gst-plugins-good-plugins-plugin-equalizer.html#plugin-equalizer">equalizer</a>
          </td>
</tr>
<tr>
<td><p><span class="term">author</span></p></td>
<td>Benjamin Otte &lt;otte@gnome.org&gt;, Stefan Kost &lt;ensonic@users.sf.net&gt;</td>
</tr>
<tr>
<td><p><span class="term">class</span></p></td>
<td>Filter/Effect/Audio</td>
</tr>
</tbody>
</table></div>
</div>
<hr>
<div class="refsect2">
<a name="id-1.2.51.8.5.2"></a><h3>Element Pads</h3>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term">name</span></p></td>
<td>sink</td>
</tr>
<tr>
<td><p><span class="term">direction</span></p></td>
<td>sink</td>
</tr>
<tr>
<td><p><span class="term">presence</span></p></td>
<td>always</td>
</tr>
<tr>
<td><p><span class="term">details</span></p></td>
<td>audio/x-raw, format=(string){ S16LE, F32LE, F64LE }, rate=(int)[ 1000, 2147483647 ], channels=(int)[ 1, 2147483647 ], layout=(string)interleaved</td>
</tr>
</tbody>
</table></div>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term">name</span></p></td>
<td>src</td>
</tr>
<tr>
<td><p><span class="term">direction</span></p></td>
<td>source</td>
</tr>
<tr>
<td><p><span class="term">presence</span></p></td>
<td>always</td>
</tr>
<tr>
<td><p><span class="term">details</span></p></td>
<td>audio/x-raw, format=(string){ S16LE, F32LE, F64LE }, rate=(int)[ 1000, 2147483647 ], channels=(int)[ 1, 2147483647 ], layout=(string)interleaved</td>
</tr>
</tbody>
</table></div>
</div>
</div>
<p>
</p>
</div>
<div class="refsect1">
<a name="gst-plugins-good-plugins-equalizer-nbands.functions_details"></a><h2>Functions</h2>
</div>
<div class="refsect1">
<a name="gst-plugins-good-plugins-equalizer-nbands.other_details"></a><h2>Types and Values</h2>
<div class="refsect2">
<a name="GstIirEqualizerNBands-struct"></a><h3>struct GstIirEqualizerNBands</h3>
<pre class="programlisting">struct GstIirEqualizerNBands;</pre>
<p>
</p>
</div>
</div>
<div class="refsect1">
<a name="gst-plugins-good-plugins-equalizer-nbands.property-details"></a><h2>Property Details</h2>
<div class="refsect2">
<a name="GstIirEqualizerNBands--num-bands"></a><h3>The <code class="literal">“num-bands”</code> property</h3>
<pre class="programlisting">  “num-bands”                <a href="http://library.gnome.org/devel/glib/unstable/glib-Basic-Types.html#guint"><span class="type">guint</span></a></pre>
<p>number of different bands to use.</p>
<p>Flags: Read / Write / Construct</p>
<p>Allowed values: [1,64]</p>
<p>Default value: 10</p>
</div>
</div>
</div>
<div class="footer">
<hr>
          Generated by GTK-Doc V1.20</div>
</body>
</html>